#include "chicken.h"

/* make_ppchar. Allocates a new char**, pointing to a newly-allocated
   list of zero-terminated char *, which are copied from the Scheme
   list of strings passed in as the parameter.
 */

char **make_ppchar(C_word list_of_strings) {
  char **res;
  C_word obj, cons = list_of_strings;
  char *this;
  char *new;
  int thisLen;
  int i;
  int len = list_length(cons);
  res = (char **)malloc((len+1) * sizeof(char *));

  for (i=0; cons!=C_SCHEME_END_OF_LIST; i++) {
    obj = C_u_i_car(cons);
    this = C_c_string(obj);
    thisLen = C_header_size(obj);
    new = malloc((1+thisLen) * sizeof(char));
    memcpy(new, this, thisLen);
    new[thisLen] = 0;
    
    res[i] = new;
    cons = C_u_i_cdr(cons); 
  }
  res[i] = NULL;
  return res;
}

void free_ppchar(char **pp) {
  int i;
  for (i=0; pp[i] != NULL; i++) {
    free(pp[i]);
  }
  free(pp);
}

int list_length(C_word cons) {
  int len = 0;
  for (; cons!=C_SCHEME_END_OF_LIST;) { len++; cons = C_u_i_cdr(cons); }
  return len;
}


/* for testing. */

void test_ppchar(char **pp) {
  int i;
  for (i=0; pp[i] != NULL; i++) {
    printf("....%s\n", pp[i]);
  }
}
